Browse Source

Cluster rabbits with autocluster plugin

`etcd` is used as a backend for `autocluster`.

Co-Authored-By: Kirill Proskurin <kproskurin@mirantis.com>
Change-Id: I98bde66da4be517fb9e4442906620fae536d4f37
Alexey Lebedeff 2 years ago
parent
commit
20f18c093c

+ 176
- 0
LICENSE View File

@@ -0,0 +1,176 @@
1
+
2
+                                 Apache License
3
+                           Version 2.0, January 2004
4
+                        http://www.apache.org/licenses/
5
+
6
+   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
7
+
8
+   1. Definitions.
9
+
10
+      "License" shall mean the terms and conditions for use, reproduction,
11
+      and distribution as defined by Sections 1 through 9 of this document.
12
+
13
+      "Licensor" shall mean the copyright owner or entity authorized by
14
+      the copyright owner that is granting the License.
15
+
16
+      "Legal Entity" shall mean the union of the acting entity and all
17
+      other entities that control, are controlled by, or are under common
18
+      control with that entity. For the purposes of this definition,
19
+      "control" means (i) the power, direct or indirect, to cause the
20
+      direction or management of such entity, whether by contract or
21
+      otherwise, or (ii) ownership of fifty percent (50%) or more of the
22
+      outstanding shares, or (iii) beneficial ownership of such entity.
23
+
24
+      "You" (or "Your") shall mean an individual or Legal Entity
25
+      exercising permissions granted by this License.
26
+
27
+      "Source" form shall mean the preferred form for making modifications,
28
+      including but not limited to software source code, documentation
29
+      source, and configuration files.
30
+
31
+      "Object" form shall mean any form resulting from mechanical
32
+      transformation or translation of a Source form, including but
33
+      not limited to compiled object code, generated documentation,
34
+      and conversions to other media types.
35
+
36
+      "Work" shall mean the work of authorship, whether in Source or
37
+      Object form, made available under the License, as indicated by a
38
+      copyright notice that is included in or attached to the work
39
+      (an example is provided in the Appendix below).
40
+
41
+      "Derivative Works" shall mean any work, whether in Source or Object
42
+      form, that is based on (or derived from) the Work and for which the
43
+      editorial revisions, annotations, elaborations, or other modifications
44
+      represent, as a whole, an original work of authorship. For the purposes
45
+      of this License, Derivative Works shall not include works that remain
46
+      separable from, or merely link (or bind by name) to the interfaces of,
47
+      the Work and Derivative Works thereof.
48
+
49
+      "Contribution" shall mean any work of authorship, including
50
+      the original version of the Work and any modifications or additions
51
+      to that Work or Derivative Works thereof, that is intentionally
52
+      submitted to Licensor for inclusion in the Work by the copyright owner
53
+      or by an individual or Legal Entity authorized to submit on behalf of
54
+      the copyright owner. For the purposes of this definition, "submitted"
55
+      means any form of electronic, verbal, or written communication sent
56
+      to the Licensor or its representatives, including but not limited to
57
+      communication on electronic mailing lists, source code control systems,
58
+      and issue tracking systems that are managed by, or on behalf of, the
59
+      Licensor for the purpose of discussing and improving the Work, but
60
+      excluding communication that is conspicuously marked or otherwise
61
+      designated in writing by the copyright owner as "Not a Contribution."
62
+
63
+      "Contributor" shall mean Licensor and any individual or Legal Entity
64
+      on behalf of whom a Contribution has been received by Licensor and
65
+      subsequently incorporated within the Work.
66
+
67
+   2. Grant of Copyright License. Subject to the terms and conditions of
68
+      this License, each Contributor hereby grants to You a perpetual,
69
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
70
+      copyright license to reproduce, prepare Derivative Works of,
71
+      publicly display, publicly perform, sublicense, and distribute the
72
+      Work and such Derivative Works in Source or Object form.
73
+
74
+   3. Grant of Patent License. Subject to the terms and conditions of
75
+      this License, each Contributor hereby grants to You a perpetual,
76
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
77
+      (except as stated in this section) patent license to make, have made,
78
+      use, offer to sell, sell, import, and otherwise transfer the Work,
79
+      where such license applies only to those patent claims licensable
80
+      by such Contributor that are necessarily infringed by their
81
+      Contribution(s) alone or by combination of their Contribution(s)
82
+      with the Work to which such Contribution(s) was submitted. If You
83
+      institute patent litigation against any entity (including a
84
+      cross-claim or counterclaim in a lawsuit) alleging that the Work
85
+      or a Contribution incorporated within the Work constitutes direct
86
+      or contributory patent infringement, then any patent licenses
87
+      granted to You under this License for that Work shall terminate
88
+      as of the date such litigation is filed.
89
+
90
+   4. Redistribution. You may reproduce and distribute copies of the
91
+      Work or Derivative Works thereof in any medium, with or without
92
+      modifications, and in Source or Object form, provided that You
93
+      meet the following conditions:
94
+
95
+      (a) You must give any other recipients of the Work or
96
+          Derivative Works a copy of this License; and
97
+
98
+      (b) You must cause any modified files to carry prominent notices
99
+          stating that You changed the files; and
100
+
101
+      (c) You must retain, in the Source form of any Derivative Works
102
+          that You distribute, all copyright, patent, trademark, and
103
+          attribution notices from the Source form of the Work,
104
+          excluding those notices that do not pertain to any part of
105
+          the Derivative Works; and
106
+
107
+      (d) If the Work includes a "NOTICE" text file as part of its
108
+          distribution, then any Derivative Works that You distribute must
109
+          include a readable copy of the attribution notices contained
110
+          within such NOTICE file, excluding those notices that do not
111
+          pertain to any part of the Derivative Works, in at least one
112
+          of the following places: within a NOTICE text file distributed
113
+          as part of the Derivative Works; within the Source form or
114
+          documentation, if provided along with the Derivative Works; or,
115
+          within a display generated by the Derivative Works, if and
116
+          wherever such third-party notices normally appear. The contents
117
+          of the NOTICE file are for informational purposes only and
118
+          do not modify the License. You may add Your own attribution
119
+          notices within Derivative Works that You distribute, alongside
120
+          or as an addendum to the NOTICE text from the Work, provided
121
+          that such additional attribution notices cannot be construed
122
+          as modifying the License.
123
+
124
+      You may add Your own copyright statement to Your modifications and
125
+      may provide additional or different license terms and conditions
126
+      for use, reproduction, or distribution of Your modifications, or
127
+      for any such Derivative Works as a whole, provided Your use,
128
+      reproduction, and distribution of the Work otherwise complies with
129
+      the conditions stated in this License.
130
+
131
+   5. Submission of Contributions. Unless You explicitly state otherwise,
132
+      any Contribution intentionally submitted for inclusion in the Work
133
+      by You to the Licensor shall be under the terms and conditions of
134
+      this License, without any additional terms or conditions.
135
+      Notwithstanding the above, nothing herein shall supersede or modify
136
+      the terms of any separate license agreement you may have executed
137
+      with Licensor regarding such Contributions.
138
+
139
+   6. Trademarks. This License does not grant permission to use the trade
140
+      names, trademarks, service marks, or product names of the Licensor,
141
+      except as required for reasonable and customary use in describing the
142
+      origin of the Work and reproducing the content of the NOTICE file.
143
+
144
+   7. Disclaimer of Warranty. Unless required by applicable law or
145
+      agreed to in writing, Licensor provides the Work (and each
146
+      Contributor provides its Contributions) on an "AS IS" BASIS,
147
+      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
148
+      implied, including, without limitation, any warranties or conditions
149
+      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
150
+      PARTICULAR PURPOSE. You are solely responsible for determining the
151
+      appropriateness of using or redistributing the Work and assume any
152
+      risks associated with Your exercise of permissions under this License.
153
+
154
+   8. Limitation of Liability. In no event and under no legal theory,
155
+      whether in tort (including negligence), contract, or otherwise,
156
+      unless required by applicable law (such as deliberate and grossly
157
+      negligent acts) or agreed to in writing, shall any Contributor be
158
+      liable to You for damages, including any direct, indirect, special,
159
+      incidental, or consequential damages of any character arising as a
160
+      result of this License or out of the use or inability to use the
161
+      Work (including but not limited to damages for loss of goodwill,
162
+      work stoppage, computer failure or malfunction, or any and all
163
+      other commercial damages or losses), even if such Contributor
164
+      has been advised of the possibility of such damages.
165
+
166
+   9. Accepting Warranty or Additional Liability. While redistributing
167
+      the Work or Derivative Works thereof, You may choose to offer,
168
+      and charge a fee for, acceptance of support, warranty, indemnity,
169
+      or other liability obligations and/or rights consistent with this
170
+      License. However, in accepting such obligations, You may act only
171
+      on Your own behalf and on Your sole responsibility, not on behalf
172
+      of any other Contributor, and only if You agree to indemnify,
173
+      defend, and hold each Contributor harmless for any liability
174
+      incurred by, or claims asserted against, such Contributor by reason
175
+      of your accepting any such warranty or additional liability.
176
+

+ 23
- 5
docker/rabbitmq/Dockerfile.j2 View File

@@ -1,15 +1,33 @@
1 1
 FROM {{ image_spec("base-tools") }}
2 2
 MAINTAINER {{ maintainer }}
3 3
 
4
-RUN apt-get install -y --no-install-recommends \
5
-    rabbitmq-server \
6
-    && apt-get clean \
7
-    && rm -rf /var/lib/rabbitmq/*
4
+# Choosing erlang version explicity, so we will not have a lot of GUI libraries
5
+{% set erlang_deps = 'erlang-nox erlang-base-hipe' %}
6
+
7
+# Runtime deps of rabbitmq
8
+{% set rabbit_run_deps = 'socat logrotate' %}
9
+
10
+# Manually managing dependencies, as we don't yet have APT repos with proper versions
11
+# of rabbitmq and autocluster.
12
+RUN apt-get install -t jessie-backports -y --no-install-recommends \
13
+  {{ erlang_deps }} {{ rabbit_run_deps }} \
14
+  && apt-get clean
15
+
16
+# We need at least 3.6.6, as it'll contain https://github.com/rabbitmq/rabbitmq-server/pull/892
17
+RUN curl -Lo /tmp/rabbitmq-server.deb https://github.com/rabbitmq/rabbitmq-server/releases/download/rabbitmq_v3_6_6_rc1/rabbitmq-server_3.6.5.906-1_all.deb \
18
+  && dpkg -i /tmp/rabbitmq-server.deb \
19
+  && rm -rf /tmp/rabbitmq-server.deb /var/lib/rabbitmq/*
20
+
21
+# `cp` is needed until https://github.com/rabbitmq/rabbitmq-server/pull/1016 is merged
22
+RUN curl -Lo /tmp/rabbitmq-autocluster.deb https://github.com/Mirantis/rabbitmq-autocluster/releases/download/0.6.1.950/rabbitmq-autocluster_0.6.1.950-1_all.deb \
23
+  && dpkg -i /tmp/rabbitmq-autocluster.deb \
24
+  && cp -v /usr/lib/rabbitmq/plugins/*.ez /usr/lib/rabbitmq/lib/rabbitmq_server-*/plugins/
8 25
 
9 26
 COPY rabbitmq_sudoers /etc/sudoers.d/rabbitmq_sudoers
27
+
10 28
 RUN chmod 750 /etc/sudoers.d \
11 29
     && chmod 440 /etc/sudoers.d/rabbitmq_sudoers \
12 30
     && usermod -a -G microservices rabbitmq \
13
-    && chown -R rabbitmq: /var/lib/rabbitmq /var/log/rabbitmq /etc/rabbitmq
31
+    && chown -R rabbitmq: /var/lib/rabbitmq /etc/rabbitmq
14 32
 
15 33
 USER rabbitmq

+ 5
- 0
service/files/defaults.yaml View File

@@ -4,4 +4,9 @@ configs:
4 4
       cont: 5672
5 5
       node: 32672
6 6
     password: password
7
+    erlang_cookie: erlang_cookie
7 8
     user: rabbitmq
9
+
10
+    # How many seconds we give a node before making liveness checks
11
+    # completely strict
12
+    node_startup_timeout: 180

+ 1
- 0
service/files/enabled_plugins.j2 View File

@@ -0,0 +1 @@
1
+[autocluster].

+ 0
- 1
service/files/erlang.cookie View File

@@ -1 +0,0 @@
1
-{{ rabbitmq.password }}

+ 1
- 0
service/files/erlang.cookie.j2 View File

@@ -0,0 +1 @@
1
+{{ rabbitmq.erlang_cookie }}

+ 92
- 0
service/files/rabbitmq-check-helpers.sh.j2 View File

@@ -0,0 +1,92 @@
1
+#!/usr/bin/env bash
2
+MARKER_PATH=/tmp/rabbit-startup-marker
3
+
4
+# How many seconds we give a node before successfull liveness checks
5
+# become mandatory.
6
+FRESH_NODE_TIMEOUT={{ rabbitmq.node_startup_timeout }}
7
+
8
+LP=""
9
+
10
+set-log-prefix() {
11
+    LP="[${1:?}]"
12
+}
13
+
14
+log-it() {
15
+    echo "$LP" "$@"
16
+}
17
+
18
+prepend-log-prefix() {
19
+    awk -v lp="$LP" '{print lp " " $0}'
20
+}
21
+
22
+marker-state() {
23
+    if [[ ! -f $MARKER_PATH ]]; then
24
+        echo "missing"
25
+        return 0
26
+    fi
27
+    local marker_time
28
+    marker_time="$(cat $MARKER_PATH)"
29
+
30
+    local end_of_fresh_time=$((FRESH_NODE_TIMEOUT + $marker_time))
31
+    local now
32
+    now=$(date +%s)
33
+    if [[ $now -le $end_of_fresh_time ]]; then
34
+        echo "fresh"
35
+        return 0
36
+    fi
37
+    echo "stale"
38
+    return 0
39
+}
40
+
41
+ping-node() {
42
+    local result
43
+    result="$(rabbitmqctl eval 'ok.' 2>&1)"
44
+    if [[ "$result" == "ok" ]]; then
45
+        return 0
46
+    fi
47
+    log-it "ping-node error:"
48
+    echo "$result" | prepend-log-prefix
49
+    return 1
50
+}
51
+
52
+is-node-booting() {
53
+    local result
54
+    result="$(rabbitmqctl eval 'is_pid(erlang:whereis(rabbit_boot)).' 2>&1)"
55
+
56
+    case "$result" in
57
+        true)
58
+            return 0
59
+            ;;
60
+        false)
61
+            return 1
62
+            ;;
63
+        *)
64
+            log-it "is-node-booting error:"
65
+            echo "$result" | prepend-log-prefix
66
+            return 1
67
+            ;;
68
+    esac
69
+}
70
+
71
+is-node-healthy() {
72
+    local result
73
+    result=$(rabbitmqctl node_health_check -t 30 2>&1)
74
+    if [[ "$result" =~ "Health check passed" ]]; then
75
+        return 0
76
+    fi
77
+    echo "$result" | prepend-log-prefix
78
+    return 1
79
+}
80
+
81
+is-node-properly-clustered() {
82
+    result="$(rabbitmqctl eval 'autocluster:cluster_health_check().' 2>&1)"
83
+    if [[ $result =~ ^SUCCESS: ]]; then
84
+        return 0
85
+    elif [[ $result =~ ^FAILURE: ]]; then
86
+        echo "$result" | prepend-log-prefix
87
+        return 1
88
+    fi
89
+    log-it "Unexpected health-check output, giving the node the benefit of the doubt"
90
+    echo "$result" | prepend-log-prefix
91
+    return 0
92
+}

+ 2
- 1
service/files/rabbitmq-env.conf.j2 View File

@@ -1,2 +1,3 @@
1
-NODENAME=rabbitmq
1
+NODENAME=rabbit@{{ network_topology["private"]["address"] }}
2
+USE_LONGNAME=true
2 3
 RABBITMQ_LOG_BASE=/var/log/ccp/rabbitmq

+ 62
- 0
service/files/rabbitmq-liveness.sh.j2 View File

@@ -0,0 +1,62 @@
1
+#!/usr/bin/env bash
2
+set -eu
3
+set -o pipefail
4
+exec 1>/proc/1/fd/2 2>/proc/1/fd/2
5
+
6
+source $(readlink -f $(dirname $0))/rabbitmq-check-helpers.sh
7
+set-log-prefix "liveness:$$"
8
+log-it "Starting liveness probe at $(date +'%Y-%m-%d %H:%M:%S')"
9
+
10
+main() {
11
+    local marker_state
12
+    marker_state="$(marker-state)"
13
+    case $marker_state in
14
+        missing)
15
+            log-it "Startup marker missing, probably probe was executed too early"
16
+            return 0
17
+            ;;
18
+        fresh) # node has recently started - it can still be booting
19
+            if ! ping-node; then
20
+                log-it "Fresh node, erlang VM hasn't started yet - giving it another chance"
21
+                # Erlang VM hasn't started yet
22
+                return 0
23
+            fi
24
+            if is-node-booting; then
25
+                log-it "Node is still booting, giving it some time to finish"
26
+                return 0
27
+            fi
28
+            if ! is-node-healthy; then
29
+                log-it "Node is unhealthy"
30
+                return 1
31
+            fi
32
+            if ! is-node-properly-clustered; then
33
+                log-it "Found clustering inconsistency, giving up"
34
+                return 1
35
+            fi
36
+            return 0
37
+            ;;
38
+        stale) # node has started long ago - it shoud be either ready or dead
39
+            if ! is-node-healthy; then
40
+                log-it "Long-running node become unhealthy"
41
+                return 1
42
+            fi
43
+            if ! is-node-properly-clustered; then
44
+                echo "Long-running node became inconsistent with the rest of the cluster"
45
+                return 1
46
+            fi
47
+            return 0
48
+            ;;
49
+        *)
50
+            log-it "Unexpected marker-state '$marker-state'"
51
+            return 1
52
+            ;;
53
+    esac
54
+}
55
+
56
+if main; then
57
+    rc=0
58
+else
59
+    rc=$?
60
+fi
61
+log-it "Ready to return $rc"
62
+exit $rc

+ 32
- 0
service/files/rabbitmq-readiness.sh.j2 View File

@@ -0,0 +1,32 @@
1
+#!/usr/bin/env bash
2
+set -eu
3
+set -o pipefail
4
+exec 1>/proc/1/fd/2 2>/proc/1/fd/2
5
+
6
+source $(readlink -f $(dirname $0))/rabbitmq-check-helpers.sh
7
+set-log-prefix "readiness:$$"
8
+log-it "Starting readiness probe at $(date +'%Y-%m-%d %H:%M:%S')"
9
+
10
+main() {
11
+    if [[ "$(marker-state)" == missing ]]; then
12
+        log-it "Startup marker missing, probably probe was executed too early"
13
+        return 1
14
+    fi
15
+    if ! is-node-healthy; then
16
+        log-it "Node is unhealthy"
17
+        return 1
18
+    fi
19
+    if ! is-node-properly-clustered; then
20
+        log-it "Node is inconsistent with the rest of the cluster"
21
+        return 1
22
+    fi
23
+    return 0
24
+}
25
+
26
+if main; then
27
+    rc=0
28
+else
29
+    rc=$?
30
+fi
31
+log-it "Ready to return $rc"
32
+exit $rc

+ 23
- 8
service/files/rabbitmq.config.j2 View File

@@ -1,11 +1,26 @@
1 1
 [
2
-  {rabbit, [
3
-    {tcp_listeners, [
4
-      {"0.0.0.0", {{ rabbitmq.port.cont }} }
5
-    ]},
6
-    {default_user, <<"{{ rabbitmq.user }}">>},
7
-    {default_pass, <<"{{ rabbitmq.password }}">>},
8
-    {cluster_partition_handling, autoheal}
9
-  ]}
2
+   {rabbit, [
3
+      {dummy_param_without_comma, true}
4
+     ,{tcp_listeners, [
5
+        {"0.0.0.0", {{ rabbitmq.port.cont }} }
6
+      ]}
7
+     ,{default_user, <<"{{ rabbitmq.user }}">>}
8
+     ,{default_pass, <<"{{ rabbitmq.password }}">>}
9
+     ,{loopback_users, []}
10
+     ,{cluster_partition_handling, pause_minority}
11
+     ,{queue_master_locator, <<"random">>}
12
+   ]}
13
+  ,{autocluster, [
14
+      {dummy_param_without_comma, true}
15
+     ,{backend, etcd}
16
+     ,{autocluster_failure, stop}
17
+     ,{cleanup_interval, 30}
18
+     ,{cluster_cleanup, true}
19
+     ,{cleanup_warn_only, false}
20
+     ,{etcd_ttl, 15}
21
+     ,{etcd_scheme, http}
22
+     ,{etcd_host, "etcd"}
23
+     ,{etcd_port, {{ etcd.client_port.cont }}}
24
+   ]}
10 25
 ].
11 26
 % EOF

+ 31
- 6
service/rabbitmq.yaml View File

@@ -1,14 +1,15 @@
1 1
 service:
2 2
   name: rabbitmq
3
+  kind: DaemonSet
3 4
   ports:
4 5
     - {{ rabbitmq.port }}
5 6
   containers:
6 7
     - name: rabbitmq
7 8
       image: rabbitmq
8 9
       probes:
9
-        readiness: "true"
10
+        readiness: "/opt/ccp/bin/rabbitmq-readiness.sh"
10 11
         liveness:
11
-          command: "true"
12
+          command: "/opt/ccp/bin/rabbitmq-liveness.sh"
12 13
           type: "exec"
13 14
       volumes:
14 15
         - name: rabbitmq-logs
@@ -19,19 +20,43 @@ service:
19 20
         - name: chown-logs-dir
20 21
           command: "sudo /bin/chown rabbitmq: /var/log/ccp/rabbitmq"
21 22
       daemon:
23
+        dependencies:
24
+          - etcd
25
+        command: /usr/lib/rabbitmq/bin/rabbitmq-server
22 26
         files:
23 27
           - rabbitmq-conf
24
-          - rabbitmq-env
25 28
           - erlang-cookie
26
-        command: rabbitmq-server
29
+          - rabbitmq-env-conf
30
+          - enabled-plugins
31
+          - rabbitmq-readiness
32
+          - rabbitmq-liveness
33
+          - rabbitmq-check-helpers
34
+      post:
35
+        - name: create-startup-marker
36
+          command: "date +%s > /tmp/rabbit-startup-marker"
27 37
 files:
28 38
   rabbitmq-conf:
29 39
     path: /etc/rabbitmq/rabbitmq.config
30 40
     content: rabbitmq.config.j2
31
-  rabbitmq-env:
41
+  rabbitmq-env-conf:
32 42
     path: /etc/rabbitmq/rabbitmq-env.conf
33 43
     content: rabbitmq-env.conf.j2
44
+  enabled-plugins:
45
+    path: /etc/rabbitmq/enabled_plugins
46
+    content: enabled_plugins.j2
34 47
   erlang-cookie:
35 48
     path: /var/lib/rabbitmq/.erlang.cookie
36
-    content: erlang.cookie
49
+    content: erlang.cookie.j2
37 50
     perm: "400"
51
+  rabbitmq-readiness:
52
+    path: /opt/ccp/bin/rabbitmq-readiness.sh
53
+    content: rabbitmq-readiness.sh.j2
54
+    perm: "755"
55
+  rabbitmq-liveness:
56
+    path: /opt/ccp/bin/rabbitmq-liveness.sh
57
+    content: rabbitmq-liveness.sh.j2
58
+    perm: "755"
59
+  rabbitmq-check-helpers:
60
+    path: /opt/ccp/bin/rabbitmq-check-helpers.sh
61
+    content: rabbitmq-check-helpers.sh.j2
62
+    perm: "644"

Loading…
Cancel
Save